#include <JGL/JGL.h>
#include <JUI/Rect.hpp>

namespace JUI {
    Rect::Rect(): Widget() {}

    Rect::Rect(Widget *parent): Rect() {
        this->SetParent(parent);
    }

    void Rect::Draw() {
        if (!visible)
            return;

        J2D::Begin();
        Vector2 abs_pos = GetAbsolutePosition();
        Vector2 abs_size = GetAbsoluteSize();

        auto root_size = GetFamilyTreeRoot()->GetAbsoluteSize();

        // TODO: Re-enable clipping


        // Background rect
        //J2D::FillRoundedRect(bg_color, abs_pos, abs_size, corner_rounding_radius);

        J2D::Begin();
            //J2D::FillRect(bg_color, abs_pos, abs_size);
        //J2D::FillRect(bg_color, abs_pos, root_size);
        J2D::FillRect(bg_color, abs_size/2, abs_size);
        // Outline rect
        if (corner_rounding_radius >= 0)
            J2D::OutlineRect(border_color, abs_pos, abs_size);
        J2D::End();
            //J2D::OutlineRoundedRect(bg_color, abs_pos, abs_size, corner_rounding_radius, border_width);


        Widget::Draw();
        // TODO: Return clip to previous state


        J2D::End();
    }


    void Rect::Update(float delta) {
        Widget::Update(delta);
    }

}


